routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/','Admin\DashboardController@viewDashboard')->name('dashboard.show');

Route::get('/dashboard','Admin\DashboardController@viewDashboard')->name('dashboard.show');
Route::get('/survey','Admin\SurveyController@viewSurvey');

//Sondage
Route::resource('sondages','Admin\SondageController');
Route::get('sondages/link/{slug}','Admin\SondageController@linkSondage')->name('link.sondage');
Route::get('sondages/stat/{sondage}','Admin\SondageController@statView')->name('stat.sondage');

//User
Route::resource('users','Admin\UserController')->except(['index']);


//Question
Route::resource('questions','Admin\QuestionController')->except(['create']);
Route::get('/questions/{sondage}/create', 'Admin\QuestionController@create')->name('question.create');

//Sous Question
Route::get('/sousquestions/{option}/create','Admin\QuestionController@createSousQuestion')->name('sousquestion.create');
Route::post('/sousquestions/store','Admin\QuestionController@storeSousQuestion')->name('sousquestion.store');
Route::get('/sousquestions/{option}/edit','Admin\QuestionController@editSousQuestion')->name('sousquestion.edit');


//GroupeDevice
Route::resource('groupesdevices','Admin\GroupeDeviceController');
Route::get('groupesdevices/stat/{groupeDevice}','Admin\GroupeDeviceController@groupesStat')->name('devices.stat');

//Devices
Route::get('/devices/{groupe}','Admin\DeviceController@viewDevice')->name('devices.view');

//Email
Route::resource('customeremails','Admin\EmailParticipantController');
Route::get('customeremail/{sondage}','Admin\EmailParticipantController@createForm')->name('customeremail.form');
Route::get('customeremail/{sondage}/mails','Admin\EmailParticipantController@sondageByMail')->name('mails.sondage');
Route::post('customeremail/store','Admin\EmailParticipantController@sendMail')->name('mails.store');
Route::get('web/sondagemail/{id}','Admin\EmailParticipantController@statistiqueEmail')->name('email.sondagemail');


//Web
Route::resource('web','Admin\WebSondageController');
Route::get('web/sondageweb/{id}','Admin\WebSondageController@statistiqueWeb')->name('web.sondageweb');
Route::get('web/sondage/{id}','Admin\WebSondageController@viewSondage')->name('web.viewsondage');



//Envoi de mail
Route::get('/sendmails','Admin\EmailParticipantController@sendmail');

//




Auth::routes();
Route::get('logout', '\App\Http\Controllers\Auth\LoginController@logout')->name('logout');

Route::get('/home', 'HomeController@index')->name('home');

app/Sondage.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Sondage extends Model
{

    protected $fillable = ['titre','logo','start_text','end_text','user_id','couleur','web','mobile','email','anonyme'];
    //



    public function getUrlAttribute()
    {
        return route("web.viewsondage", $this->id);
    }



    public function questions()
    {

        return $this->hasMany(Question::class)->orderBy('id');
    }//


    public function getAttributeTitre()
    {
        return $this->titre;
    }

    public function user(){
        return $this->belongsTo(User::class);
    }

    public function reponses(){
        return $this->hasMany(Reponse::class);
    }



    public function groupeDevices(){

        return $this->hasMany(GroupeDevice::class);
    }

    public function emails(){

        return $this->belongsToMany(EmailParticipant::class)->withPivot('token','is_use','url')->withTimestamps();
    }
}

app/Http/Controllers/Admin/SondageController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Device;
use App\GroupeDevice;
use App\Http\Requests\SondageRequest;
use App\Participant;
use App\Sondage;
use App\Question;
use App\Option;
use App\Reponse;
use App\User;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Auth;

class SondageController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */


    public function __construct()
    {
        $this->middleware('auth');
    }


    public function index()
    {
        $sondages = User::findOrfail(Auth::user()->id)->sondages;


        return view('back.sondage.index', compact('sondages'));
    }


    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('back.sondage.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        request()->validate([
            'titre' => 'required',
            'logo' => 'required',
            'start' => 'required',
            'end' => 'required'

        ]);


        $sondage = new Sondage();
        $imageName = time() . '.' . request()->logo->getClientOriginalExtension();
        request()->logo->move(public_path('images/admin/sondages'), $imageName);
        $sondage->logo = $imageName;
        $sondage->titre = $request->titre;
        $sondage->start_text = $request->start;
        $sondage->end_text = $request->end;
        $sondage->web = $request->web;
        $sondage->mobile = $request->mobile;
        $sondage->email = $request->mail;
        $sondage->couleur = $request->couleur;
        $sondage->anonyme = $request->anonyme;
        $sondage->user_id = Auth::user()->id;
        $sondage->save();

        if ($request->anonyme == 1) {
            $question = new Question();
            $question->titre_question = "Votre contact s'il vous plaît !?";
            $question->type_reponse_id = 8;
            $question->is_sousquestion = 0;
            $question->sondage_id = $sondage->id;
            $question->mandatory = 1;
            $question->save();
        }


        return redirect()->route('sondages.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Sondage $sondage
     * @return \Illuminate\Http\Response
     */
    public function show(Sondage $sondage)
    {
        if($sondage->user_id != Auth::user()->id)
            abort(404);
        $match_close = ['sondage_id' => $sondage->id, 'is_sousquestion' => 0];
        $questions = Question::where($match_close)->get();
        $questions_array = $questions->toArray();
        $nbr_reponse = Sondage::findOrFail($sondage->id)->reponses->count();
        $sumOfYes = 0;
        $sumOfNo = 0;
        $sumOfGood = 0;
        $sumOfBad = 0;


        foreach ($questions_array as $key => $question) {
            //dd($question);
            $options = Option::where('question_id', $question['id'])->get()->toArray();
            $opt_repAll = Reponse::where('question_id', $question['id'])->get()->count();

            if ($question['type_reponse_id'] == 8) {
                $participant_ids = Reponse::select('participant_id')->where('sondage_id', $question['sondage_id'])->distinct('participant_id')->get()->toArray();
                $participant = array();
                foreach ($participant_ids as $participant_id) {
                    $part = Participant::find($participant_id)->toArray();
                    if ($part != null) {
                        $participant[] = $part;
                    }
                }
                $questions_array[$key]['participants'] = $participant;
                //dd($participant);
            }
            if (in_array($question['type_reponse_id'], [1, 2, 3, 4])) {
                //dd($options);
                $options = Option::where('question_id', $question['id'])->get()->toArray();
                $data = '[';
                $per = '[';
                $questions_array[$key]['options'] = $options;
                if ($opt_repAll > 0) {
                    foreach ($options as $key2 => $option) {
                        $opt_rep = Reponse::where('answer', $option['id'])->get()->count();
                        if ($option['default_option_id'] == 1 || $option['default_option_id'] == 2)
                            $sumOfGood += $opt_rep;
                        if ($option['default_option_id'] == 3 || $option['default_option_id'] == 4)
                            $sumOfBad += $opt_rep;
                        if ($option['default_option_id'] == 5)
                            $sumOfYes += $opt_rep;
                        if ($option['default_option_id'] == 6)
                            $sumOfNo += $opt_rep;
                        $percent = ($opt_rep * 100) / $opt_repAll;
                        $questions_array[$key]['options'][$key2]['stat'] = round($percent, 2);

                        if ($options[count($options) - 1] == $option) {
                            $data .= '"' . $option['titre_option'] . '"]';
                            $per .= '"' . round($percent, 2) . '"]';
                        } else {
                            $data .= '"' . $option['titre_option'] . '",';
                            $per .= '"' . round($percent, 2) . '",';
                        }
                        $questions_array[$key]['data'] = $data;
                        $questions_array[$key]['per'] = $per;

                        //dd($percent);
                    }
                    //dd($sumOfGood);

                }

            }
            if (in_array($question['type_reponse_id'], [9,10])) {
                //dd($options);
                $data = '[';
                $per = '[';
                $questions_array[$key]['options'] = $options;
                $opt_repAll = 0;
                foreach($options as $opt){
                    //dd($opt);
                    $opt_repAll += Reponse::where([['question_id', $question['id']],['answer','LIKE','%'.$opt['id'].'%']])->get()->count();
                }
                if ($opt_repAll > 0) {

                    foreach ($options as $key2 => $option) {
                        $opt_rep = Reponse::where([['question_id', $question['id']],['answer','LIKE','%'.$option['id'].'%']])->get()->count();
                        $percent = ($opt_rep * 100) / $opt_repAll;
                        $questions_array[$key]['options'][$key2]['stat'] = round($percent, 2);

                        if ($options[count($options) - 1] == $option) {
                            $data .= '"' . $option['titre_option'] . '"]';
                            $per .= '"' . round($percent, 2) . '"]';
                        } else {
                            $data .= '"' . $option['titre_option'] . '",';
                            $per .= '"' . round($percent, 2) . '",';
                        }
                        $questions_array[$key]['data'] = $data;
                        $questions_array[$key]['per'] = $per;

                        //dd($percent);
                    }
                    //dd($sumOfGood);

                }

            }
            if (in_array($question['type_reponse_id'], [5, 6, 7])) {
                $quest_rep = Reponse::select('answer')->where('question_id', $question['id'])->get()->toArray();
                $questions_array[$key]['reponses'] = $quest_rep;

            }

        }


        $globalStat = ["smile" => ["happy" => $sumOfGood, "sad" => $sumOfBad], "trueFalse" => ["yes" => $sumOfYes, "no" => $sumOfNo]];
        // add something
        //dd($sumOfNo);
        return view('back.sondage.show', compact('sondage', 'questions', 'questions_array', 'nbr_reponse', 'globalStat'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Sondage $sondage
     * @return \Illuminate\Http\Response
     */
    public
    function edit(Sondage $sondage)
    {


        return view('back.sondage.edit', compact('sondage'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @param  \App\Sondage $sondage
     * @return \Illuminate\Http\Response
     */
    public
    function update(SondageRequest $request, Sondage $sondage)
    {
        $imageName = "";
        if(isset($request->logo) != ""){
            $imageName = time() . '.' . request()->logo->getClientOriginalExtension();
            request()->logo->move(public_path('images/admin/sondages'), $imageName);
        }

        $sondage->update([
            'titre' => $request->titre,
            'couleur' => $request->couleur,
            'logo' => $imageName,
            'start_text' => $request->start_text,
            'end_text' => $request->end_text,
        ]);

        return redirect()->route('sondages.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Sondage $sondage
     * @return \Illuminate\Http\Response
     */
    public
    function destroy(Sondage $sondage)
    {

        $groupes = GroupeDevice::where('sondage_id', $sondage->id)->get();


        foreach ($groupes as $groupe) {
            Device::where('groupe_device_id', $groupe->id)->delete();
        }

        GroupeDevice::where('sondage_id', $sondage->id)->delete();
        $sondage->delete();

        return redirect()->route('sondages.index');
    }




    public function statView(Sondage $sondage){
        if($sondage->user_id != Auth::user()->id)
            abort(404);
        $match_close = ['sondage_id' => $sondage->id, 'is_sousquestion' => 0];
        $questions = Question::where($match_close)->get();
        $questions_array = $questions->toArray();

resources/views/back/sondage/edit.blade.php
    <div>
        <!-- .row -->
        <div class="row">
            <div class="col-sm-12">
                <div class="white-box">
                    <h3 class="box-title m-b-0">Modifier le sondage</h3>
                    <p class="text-muted m-b-30 font-13">  </p>
                    <form class="form-horizontal" method="POST" action="{{route('sondages.update',$sondage->id)}}" enctype="multipart/form-data" >
                        @csrf
                        <div class="form-group  @if($errors->has('titre')) has-error @endif">
                            <label class="col-md-12">Titre</label>
                            <div class="col-md-12">
                                <input type="text" class="form-control" value="{{ $sondage->titre }}"  name="titre">
                                @if($errors->has('titre'))
                                    <span class="help-block"> Titre non conforme. </span>
                                @endif
                            </div>
                        </div>
                        <div class="form-group  @if($errors->has('logo')) has-error @endif">
                            <label class="col-md-12">Logo</label>
                            <div class="col-md-12">
                                <input type="file" id="input-file-now" class="dropify" name="logo" value="{{ asset('public/images/admin/sondages/'.$sondage->logo) }}" data-default-file="{{ asset('public/images/admin/sondages/'.$sondage->logo) }}"/>
                                @if($errors->has('logo'))
                                    <span class="help-block"> Image pas compatible. </span>
                                @endif
                            </div>
                        </div>
                        <div class="form-group @if($errors->has('start')) has-error @endif">
                            <label class="col-md-12">Mot de Bienvenue</label>
                            <div class="col-md-12">
                                <input type="text" class="form-control" value="{{ $sondage->start_text }}" name="start">
                                @if($errors->has('start'))
                                    <span class="help-block"> Mot de debut requis </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group @if($errors->has('end')) has-error @endif">
                            <label class="col-md-12">Mot de fin</label>
                            <div class="col-md-12">
                                <input type="text" class="form-control" value="{{ $sondage->end_text }}" name="end">
                                @if($errors->has('end'))
                                    <span class="help-block"> Mot de fin requis </span>
                                @endif
                            </div>
                        </div>
                        <div class="form-group @if($errors->has('couleur')) has-error @endif">
                            <label class="col-md-12">Choix de la couleur</label>
                            <div class="col-md-12">
                                <div class="col-md-3">
                                    <input type="color" class="form-control" value="{{ $sondage->couleur }}" name="couleur">
                                </div>
                                @if($errors->has('couleur'))
                                    <span class="help-block"> definir une couleur </span>
                                @endif
                            </div>
                        </div>
                        <!--<div class="form-group row ">
                            <label class="col-md-12">Plateforme</label>
                            <div class="col-md-8">
                                <div class="checkbox checkbox-success  col-md-2">
                                    <input id="checkbox1" type="hidden" name="mobile" value="0">
                                    <input id="checkbox1" type="checkbox" name="mobile" value="1">
                                    <label for="checkbox1"> Mobile </label>
                                </div>
                                <div class="checkbox checkbox-success col-md-2">
                                    <input id="checkbox2" type="hidden" name="web" value="0">
                                    <input id="checkbox2" type="checkbox" name="web" value="1">
                                    <label for="checkbox2"> Web </label>
                                </div>
                                <div class="checkbox checkbox-success col-md-2">
                                    <input id="checkbox3" type="hidden" name="mail" value="0">
                                    <input id="checkbox3" type="checkbox" name="mail" value="1">
                                    <label for="checkbox3"> Mail </label>
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-md-12">Sondage Anonyme</label>
                            <div class="radio-list">
                                <label class="radio-inline p-0">
                                    <div class="radio radio-info">
                                        <input type="radio" checked="checked" name="anonyme" id="radio1" value="0">
                                        <label for="radio1">Oui</label>
                                    </div>
                                </label>
                                <label class="radio-inline">
                                    <div class="radio radio-info">
                                        <input type="radio" name="anonyme" id="radio2" value="1">
                                        <label for="radio2">Non </label>
                                    </div>
                                </label>
                            </div>
                        </div>-->


                        <button type="submit" class="btn btn-success"> Modifier le sondage</button>
                        <button  class="btn btn-danger" onclick="location.href='{{route('sondages.show',$sondage)}}'"> Annuler</button>

                    </form>
                </div>
            </div>
        </div>
        <!-- /.row -->
        <!-- ===== Right-Sidebar-End ===== -->
    </div>

resources/views/back/sondage/index.blade.php
@extends('back.layout.app')

@section('content')

    <div class="container-fluid">
        <div class="white-box text-center">
            <h1>SONDAGES</h1>
        </div>


        <div class="row  bg-transparent">
            <div class="col-md-2">
                <div class="row">
                    <div class="col-md-4">

                    </div>
                    <div class="col-md-4">
                        <br> <br> <br>
                        <button type="button" class="btn btn-danger btn-circle btn-xl" onclick="location.href='{{route('sondages.create')}}'"><i class="fa fa-plus"></i> </button>
                    </div>
                </div>
            </div>
            <div class="col-md-10">
                <div class="row">
                    @foreach($sondages as $sondage)
                    <div class="col-md-3 ">
                        <div class="ribbon-wrapper-right-bottom bg-white">
                            <div class="ribbon ribbon-corner ribbon-info ribbon-right ribbon-bottom"><a href="#deleteSondage" data-toggle="modal" data-sondage-id="{{$sondage->id}}" data-sondage-titre="{{$sondage->titre}}"><i class="fa fa-trash fa-2x" data-toggle="modal"></i></a></div>
                            <div class="ribbon-content text-center ">
                                <a href="{{route('sondages.show',$sondage->id)}}">
                                    <img src="{{asset('images/admin/survey.png')}}" width="110" height="100">
                                </a>
                            </div>
                            <br>
                            <div class="text-center font-20">
                                {{ $sondage->titre }}
                            </div>
                            <br>
                            <div class="text-center row">
                                <div class="col-sm-offset-2 col-sm-3 btn white-box " title="@if ($sondage->mobile===1) actif @else inactif  @endif">
                                    <i class="fa fa-tablet fa-2x @if ($sondage->mobile===1) text-success  @endif" aria-hidden="true" ></i>
                                </div>
                                <div class="col-sm-3 btn white-box " title="@if ($sondage->web===1) actif @else inactif  @endif">
                                    <i class="fa fa-globe fa-2x @if ($sondage->web===1) text-success  @endif" aria-hidden="true" ></i>

                                </div>
                                <div class="col-sm-3 btn white-box" title="@if ($sondage->email===1) actif @else inactif  @endif">
                                    <i class="fa fa-envelope fa-2x @if ($sondage->email===1) text-success  @endif" aria-hidden="true"></i>
                                </div>

                            </div>
                        </div>
                        <br>
                    </div>
                     @endforeach
                </div>

            </div>


        </div>

    </div>

    <div id="deleteSondage" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    <h4 class="modal-title" id="myModalLabel">Supprimer</h4> </div>
                <div class="modal-body">
                    <h4>Ête vous de supprimer ce sondage <span id="sondageTitre"> </span>?</h4>
                </div>
                <div class="modal-footer">
                    <form id="userForm" action="" method="post">
                        @csrf
                        @method('DELETE')
                        <input type="hidden" name="id">
                        <button type="button" class="btn btn-default" data-dismiss="modal">Fermer</button>
                        <button type="submit" class="btn btn-danger">Supprimer</button>
                    </form>
                </div>
            </div>
            <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
    </div>


@endsection

@section('scripts')

    <script>

        $('#deleteSondage').on('show.bs.modal', function(e) {


            var sondageId = $(e.relatedTarget).data('sondage-id');
            var sondageTitre = $(e.relatedTarget).data('sondage-titre');


            $('#userForm').attr("action", "{{ url('/sondages') }}" + "/" + sondageId);
            $('#sondageTitre').val(sondageTitre)
        });

    </script>

@endsection

resources/views/back/sondage/overview.blade.php
@extends('back.layout.app')
@section('content')

    <stat stats="{{json_encode($statData)}}"></stat>

@endsection

resources/views/back/sondage/questions.blade.php
<div class="row">
    <div class="col-md-12 row">
        <div class="col-md-4 row" xmlns:v-on="http://www.w3.org/1999/xhtml" xmlns:v-on="http://www.w3.org/1999/xhtml"
             xmlns:v-on="http://www.w3.org/1999/xhtml" xmlns:v-on="http://www.w3.org/1999/xhtml">
            @if(isset($sondage))
                @include('back.sondage.common.nav_question')
            @endif

        </div>
        <form class="form-horizontal" method="POST" action="{{ route('questions.store') }}" enctype="multipart/form-data">
            @csrf
            <div class="col-md-8 pull-right row white-box">
                <div class="form-group col-sm-12 row">
                    <label class="col-md-12">Entrer la question : <span class="help"> e.x. "aimez-vous les bonobos?"</span></label>
                    <div class="col-md-12">
                        <input type="text" class="form-control" value="" name="question_lbl" required>
                        <input type="hidden" class="form-control" value="{{$sondage->id}}" name="sondage_id">
                    </div>
                </div>
                <div class="form-group col-sm-12 row text text-warning">
                    <div class="col-md-12"><input type="checkbox" id="mandatory" name="mandatory" value="1">
                        <label for="mandatory" class="">Rendre la question obligatoire<sup>(*)</sup></label></div>
                </div>
                @include('back.sondage.common.option_nav')
                <div class="col-md-12 m-10 p-20 shadow">
                    <button type="submit" class="btn btn-success btn-lg form-control ">Cliquez ici pour créer la question</button>
                </div>
            </div>

        </form>

        <div class="clearfix "></div>
    </div>
</div>

@section('scripts')

    <script>

    </script>

    @endsection

resources/views/back/sondage/show.blade.php
@extends('back.layout.app')
@section('content')

    <questions inline-template>
        <div class="container-fluid">
            <div class="m-t-20">
                <div class="row">
                    <div class="col-md-12 col-lg-12 col-xs-12">
                        <div class="">
                            <ul class="nav customtab2 nav-tabs white-box" role="tablist">
                                <li role="presentation" class="active"><a href="#question6" aria-controls="questions"
                                                                          role="tab"
                                                                          data-toggle="tab" aria-expanded="false"><span
                                                class="visible-xs"><i class="ti-user"></i></span> <span class="hidden-xs">Questions</span></a>
                                </li>
                                <li role="presentation" class=""><a href="#messages6" aria-controls="messages" role="tab"
                                                                    data-toggle="tab" aria-expanded="false"><span
                                                class="visible-xs"><i class="ti-email"></i></span> <span class="hidden-xs">Modifier</span></a>
                                </li>
                            </ul>
                            <!-- Tab panes -->
                            <div class="tab-content">
                                <div role="tabpanel" class="tab-pane fade active in" id="question6">
                                    @include('back.sondage.questions')
                                </div>
                                <div role="tabpanel " class="tab-pane fade" id="messages6">
                                    @include('back.sondage.edit')
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

    </questions>

@endsection